/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TCentralComponent_h_
#define _TCentralComponent_h_
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
class TTextEditor;
//---------------------------------------------------------------------
// Класс компонента содержимого.
// Наследует класс модели меню
class TCentralComponent  : public Component,
                           public MenuBarModel
{
public:
    TCentralComponent();
    ~TCentralComponent();

    // Идентификаторы команд меню
    enum TMenuOptions
    {
        FileOpen = 1, // Открыть файл
        FileQuit = 2, // Завершить работу с программой
        EditCut = 3, // Вырезать текст
        EditCopy = 4, // Скопировать текст в буфер
        EditPaste = 5 // Вставить текст из буфера
    };

    void paint(Graphics&);
    void resized();
    // Функции, наследуемые от MenuBarModel
    const StringArray getMenuBarNames();
    const PopupMenu getMenuForIndex(int, const String&);
    void menuItemSelected(int, int);

private:
    // Наш текстовый редактор
    // с поддержкой drag and drop
    TTextEditor* pTextEditor;
    
    // Изображения - пиктограммы меню
    Image ImageOpen_png;
    Image ImageExit_png;
    Image ImageCut_png;
    Image ImageCopy_png;
    Image ImagePaste_png;

    // Предотвращает создание копии конструктора и оператора =
    TCentralComponent(const TCentralComponent&);
    const TCentralComponent& operator= (const TCentralComponent&);
};
//---------------------------------------------------------------------
#endif
