/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TTextEditor.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TTextEditor::TTextEditor(const String& sComponentName) : TextEditor(sComponentName)
{
    Font NewFont(20.0);
    this->setFont(NewFont);
    this->setMultiLine(true);
    this->setReturnKeyStartsNewLine(true);
    this->setReadOnly(false);
    this->setScrollbarsShown(true);
    this->setCaretVisible(true);
    this->setPopupMenuEnabled(true);
    this->setText(String::empty);
}
//---------------------------------------------------------------------
TTextEditor::~TTextEditor()
{
}
//---------------------------------------------------------------------
bool TTextEditor::isInterestedInFileDrag(const StringArray&)
{
    // Обрабатываются любые файлы
    return true;
}
//---------------------------------------------------------------------
void TTextEditor::filesDropped(const StringArray& sFiles, int iX, int iY)
{
    // Получаем брошенный на компонент файл
    // по пути к нему
    File DroppedFile(sFiles[0]);
    // Если это текстовый файл...
    if(DroppedFile.getFileExtension() == ".txt")
    {
        // выводим его содержимое на комонент
        FileInputStream Input(DroppedFile);
        this->setText(Input.readEntireStreamAsString());
        repaint();
    }
    // Иначе выводим предупреждение
    else AlertWindow::showMessageBox(AlertWindow::WarningIcon, tr("Ошибка"), tr("Неподдерживаемый тип файла!"), tr("Принять"), 0);
}
//---------------------------------------------------------------------
